#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

std::vector<vector<long long>> g;
std::vector<long long> tops, used;

void dfs(long long v) {
    used[v] = 1;
    for (auto & u : g[v]) {
        if (!used[u]) dfs(u);
    }
    tops.push_back(v);
}

void solve() {
    long long n, m;
    std::cin >> n >> m;
    g.assign(n + 1, std::vector<long long>());
    tops.clear();
    used.assign(n + 1, 0);
    for (int i = 0, u, v; i < m; ++i) {
        std::cin >> u >> v;
        g[u].push_back(v);
    }
    for (int i = 1; i <= n; ++i) {
        if (!used[i]) dfs(i);
    }
    std::reverse(tops.begin(), tops.end());
    std::vector<long long> ind(n + 1, 0);
    for (int i = 0; i < (int)tops.size(); ++i) {
        ind[tops[i]] = i;
    }
    long long count = 0;
    for (int i = 1; i <= n; ++i) {
        for (auto u : g[i]) {
            if (ind[i] < ind[u]) count++;
        }
    }
    if ((m + 1) / 2 > count) {
        std::cout << "-1";
        return;
    }
    for (auto u : tops) std::cout << u << ' ';
}



int main() {
    cin.tie(0)->sync_with_stdio(false);
    int tests = 1; cin >> tests;
    while (tests--) {
        solve();
        cout << '\n';
    }
}