#include <bits/stdc++.h>

const long long mod = 998244353;

using namespace std;

int bin_pow(int x, int y)
{
    if (y == 0) return 1;
    if (y == 1) return x;

    int q = bin_pow(x, y / 2);
    q = 1ll * q * q % mod;

    if (y & 1) q = q * 1ll * x % mod;
    return q;
}

int get_number(const vector<int>&a)
{
    int odd = 0;
    int accumulated = 0;
    for (int i = 0; i < a.size(); i++)
    {
        int b = a[i];
        if (odd)
        {
            b = 2 - a[i];
        }
        odd *= 3;
        odd += b;
        odd %= 2;
        accumulated += (1ll * bin_pow(3, a.size() - i - 1) * b) % mod;
        accumulated %= mod;
    }

    return accumulated;
}


int compare(const vector<int> &a, const vector<int> &b)
{
    int odda = 0;
    int oddb = 0;
    for (int i = 0; i < a.size(); i++)
    {
        int ba = a[i];
        int bb = b[i];
        if (odda)
        {
            ba = 2 - a[i];
        }
        if (oddb)
        {
            bb = 2 - b[i];
        }
        odda *= 3;
        odda += ba;
        odda %= 2;
        
        oddb *= 3;
        oddb += bb;
        oddb %= 2;
        if (ba > bb)
        {
            return 1;
        } 
        if (ba < bb) {
            return -1;
        }
    }
    return 0;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<int> a(n), b(n);
        for (int i = 0; i < n; i++)
        {
            cin >> a[i]; 
            a[i]--;
        }
        for (int i = 0; i < n; i++)
        {
            cin >> b[i];
            b[i]--;
        }
        reverse(a.begin(), a.end());
        reverse(b.begin(), b.end());

        int x = get_number(a);
        int y = get_number(b);

        // cout << get_number(a) << endl;
        // cout << get_number(b) << endl;
        
        if (compare(a, b) == -1){
             cout << (get_number(b) - get_number(a) + mod) % mod ;
        }

        if (compare(a, b) == 1){
             cout << (get_number(a) - get_number(b) + mod) % mod ;
        }

        if (compare(a, b) == 0) {
            cout << 0 ;
        }

        cout << endl;
    }

    return 0;
}
