#include <iostream>
#include <algorithm>
#include <vector>
#include <set>

using namespace std;

void solve() {
    int n; cin >> n;
    vector<int> h(n); for (int &x : h) cin >> x;
    vector<int> p(n); for (int &x : p) cin >> x;

    int H = *max_element(p.begin(), p.end()) + 1;

    vector<int> mxr(H, -1);
    vector<int> lbound(H, 0);
    vector<int> ubound(H, 1e9);

    for (int i = 0; i < n; i++) {
        if (h[i] > p[i]) {
            cout << -1 << '\n'; return;
        }
        if (h[i] < p[i]) {
            mxr[h[i] + 1] = max(mxr[h[i] + 1], p[i]);
        }
        ubound[h[i]] = p[i] - h[i];
    }

    int cur_mxr = -1;
    for (int h = 0; h < H; h++) {
        //cout << mxr[h] << ' ';
        cur_mxr = max(cur_mxr, mxr[h]);
        lbound[h] = max(0, cur_mxr - h + 1);
    }
    //cout << '\n';

    /*cout << "lbound: ";
    for (int i = 0; i < H; i++)
        cout << lbound[i] << ' ';
    cout << '\n';
    cout << "ubound: ";
    for (int i = 0; i < H; i++)
        cout << ubound[i] << ' ';
    cout << '\n';*/

    int ans = 0;
    for (int h = 0; h < H; h++) {
        ans = max(ans, lbound[h]);
        if (ans > ubound[h]) {
            cout << -1 << '\n'; return;
        }
    }
    cout << ans << '\n';
}

int main() {
    int t; cin >> t;
    while (t--) {
        solve();
    }
}
