#define _GLIBCXX_DEBUG 1

#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/priority_queue.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;
//namespace r = ranges;
//namespace v = views;

typedef unsigned int uint;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#ifdef LOCAL
//#include "debug.h"
#else
#define debug(...) 533
#endif

template <typename K, typename V, template <typename> typename Comp = less> using ordered_map = tree<K, V, Comp<K>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename T, template <typename> typename Comp = less> using ordered_set = ordered_map<T, null_type, Comp>;
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
template<typename T> T random(T l, T r) { return uniform_int_distribution<T>(l, r)(rng); }

const ll mod = 998244353;

template<typename T, const T MOD>
struct modint {
    T val;
    modint(const T x = 0) {
        val = x % MOD;
        if (val < 0) val += MOD;
    }
    [[nodiscard]] modint binpow(modint x, T p) const {
        auto res = modint(1);
        while (p) {
            if (p & 1) res *= x;
            x *= x;
            p >>= 1;
        }
        return res;
    }
    [[nodiscard]] modint inv() const {
        return binpow(*this, MOD - 2);
    }
    modint operator+(const modint &x) const { return {val + x.val < MOD ? val + x.val : val + x.val - MOD}; }
    modint operator-(const modint &x) const { return {val - x.val < 0 ? val - x.val + MOD : val - x.val}; }
    modint operator*(const modint &x) const { return {(val * x.val) % MOD}; }
    modint operator/(const modint &x) const { return {(val * x.inv().val) % MOD}; }
    modint operator+=(const modint &x) { return *this = *this + x; }
    modint operator-=(const modint &x) { return *this = *this - x; }
    modint operator*=(const modint &x) { return *this = *this * x; }
    modint operator/=(const modint &x) { return *this = *this / x; }
    modint operator^(const modint &x) const { return binpow(*this, x.val); }
    bool operator==(const modint &x) const { return val == x.val; }
    bool operator!=(const modint &x) const { return val != x.val; }

    friend istream& operator>> (istream &in, modint &d) { return in >> d.val; }
    friend ostream& operator<< (ostream &out, const modint &d) { return out << d.val; }
};

typedef modint<ll, mod> mint;

int cmp(const vector<int> &a, const vector<int> &b) {
    int n = int(a.size());
    bool inv = false;
    for (int i = n - 1; i >= 0; --i) {
        if (a[i] < b[i]) return inv ? 1 : -1;
        if (a[i] > b[i]) return inv ? -1 : 1;
        if (a[i] == 2) inv = !inv;
    }
    return 0;
}


mint cost2(int i, const vector<int> &a, const vector<mint> &full_cost, bool inv);

mint cost(int i, const vector<int> &a, const vector<mint> &full_cost, bool inv) {
    mint res = cost2(i, a, full_cost, inv);
    // for (int j = 0; j <= i; ++j) {
    //     cout << a[j] << " ";
    // }
    // cout << (inv ? "inv" : "") << ": ";
    // cout << res << "\n";
    return res;
}

mint cost2(int i, const vector<int> &a, const vector<mint> &full_cost, bool inv) {
    if (i == -1) return 0;
    int cur = inv ? 4 - a[i] : a[i];
    if (cur == 1) {
        return cost(i - 1, a, full_cost, inv);
    } else if (cur == 2) {
        return cost(i - 1, a, full_cost, !inv) + full_cost[i] * 2 + 1;
    } else if (cur == 3) {
        return cost(i - 1, a, full_cost, inv) + full_cost[i] * 4 + 2;
    }
}

void solve(istream &cin = std::cin, ostream &cout = std::cout) {
    int n;
    cin >> n;
    vector<int> a(n), b(n);

    vector<mint> full_cost(n + 1);
    full_cost[0] = 0;
    for (int i = 1; i <= n; ++i) {
        full_cost[i] = full_cost[i - 1] * 3 + 1;
    }

    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }

    if (cmp(a, b) <= 0) {
        cout << cost(n - 1, b, full_cost, false) - cost(n - 1, a, full_cost, false) << "\n";
    } else {
        cout << cost(n - 1, a, full_cost, false) - cost(n - 1, b, full_cost, false) << "\n";
    }
}
/*

*/
signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    int test = 1;
#if LOCAL
    ifstream cin("../kolya.in"); // ofstream cout("../kolya.out");
    cin >> test;
    if (test == 0) cerr << "CHANGE .IN FILE" << endl;
    for (int i = 1; i <= test; i++) {
        const auto divider = string(30, '=');
        cout << divider << ' ' << i << ' ' << divider << '\n';
        solve(cin, cout);
        cout << '\n';
    }
#else
    // ifstream cin(".in"); ofstream cout(".out");
    cin >> test;
    for (int i = 0; i < test; i++) {
        solve(cin, cout);
    }
#endif
}