#include <bits/stdc++.h>

using namespace std;

using ll = long long;

template<typename T>
ostream& operator<<(ostream& ost, vector<T>& v){
    ost<<"[";
    for(auto x : v)
        ost<<x<<" ";
    return ost<<"]\n";
}

vector<int> st, fn;

ll fpow(ll a, int n, ll p){
    ll res = 1;
    for(; n>0; n >>= 1, a = a*a%p)
        if(n&1)
            res = res*a%p;
    return res;
}

ll inv(ll a, ll p){
    return fpow(a, p - 2, p);
}

ll p = 998244353;

vector<ll> a, b;

ll d(int x, int y, int n){
    //<<"d "<<n<<endl;
    if(x == y)
        return 0;
    if(abs(x - y) == 1)
        return a[n];
    return b[n];
}

ll calc(int n, int ml, int pml, bool front){
    //cout<<"st "<<n<<" "<<ml<<" "<<pml<<" "<<front<<endl;
    auto& v = front ? st : fn;
    if(n == 0)
        return 0;
    int x = v[n-1];
    if(x == ml)
        return calc(n-1, pml, pml, front);
    if(abs(x - ml) == 2)
        return (calc(n-1, ml, ml, front) + b[n-1] + 2 + d(x, pml, n - 1)) % p;
    return (calc(n-1, ml^x, ml^x, front) + 1 + d(pml, ml^x, n - 1)) % p;
}

void precalc(){
    int maxn = 1e5 + 1;
    a.resize(maxn), b.resize(maxn);
    a[0] = b[0] = 0;
    a[1] = 1;
    b[1] = 2;
    for (int i = 2; i < maxn; ++i)
    {
        b[i] = (3*b[i-1] + 2)%p;
        a[i] = (a[i-1] + b[i-1] + 1)%p;
    }
}

void solve(){
    int n;
    cin>>n;
    st.assign(n, 0);
    fn.assign(n, 0);
    for (int i = 0; i < n; ++i)
    {
        cin>>st[i];
    }
    for (int i = 0; i < n; ++i)
    {
        cin>>fn[i];
    }
    while(n > 0 && st.back() == fn.back()){
        --n;
        st.pop_back();
        fn.pop_back();
    }
    if(n == 0){
        cout<<0<<"\n";
        return;
    }
    ll ans = 0;
    int x = st.back(), y = fn.back();
    if(abs(x-y) == 2){
        ans = calc(n, 2, x<y?3:1, true) + b[n-1] + calc(n, 2, x<y?1:3, false);
    }
    else{
        ans = calc(n, x, x^y, true) + 1 + calc(n, y, x^y, false);
    }
    ans%=p;
    cout<<ans<<"\n";
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    precalc();
    int n;
    cin>>n;
    while(n--)
        solve();
}
