// ConsoleApplication1.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>
#include <string>
#include <map>
#include <set>
using namespace std;

#define ll long long

int main()
{
	int n, e;

	cin >> n >> e;

	set<char> unique_symbols;
	vector<string> Ls(n);
	for (auto i = 0; i < n; ++i)
	{
		cin >> Ls[i];

		for (size_t k = 0; k < Ls[i].size(); ++k)
			unique_symbols.insert(Ls[i][k]);
	}

	if (unique_symbols.size() < e)
	{
		for (auto letter = 'a'; letter <= /*'a' + e - 1*/ 'z'; ++letter)
			if (!unique_symbols.count(letter))
			{
				cout << letter;
				return 0;
			}
	}

	set<char> unique_first_symbols;
	for (auto const& L : Ls)
		unique_first_symbols.insert(L.front());

	if (unique_first_symbols.size() < e)
	{
		for (auto letter = 'a'; letter <= 'z'; ++letter)
			if (!unique_first_symbols.count(letter))
			{
				cout << letter;
				return 0;
			}
	}

	map<char, ll> first_sym_counts;
	for (auto const& L : Ls)
	{
		char first_sym = L.front();
		if (first_sym_counts.count(first_sym) && first_sym_counts[first_sym] == -1)
			continue;
		first_sym_counts[first_sym]++;
		if (L.size() == 1)
			first_sym_counts[first_sym] = -1;
		for (size_t i = 1; i < L.size() && first_sym == L[i]; ++i)
		{
			first_sym_counts[first_sym]++;
			if (i == L.size() - 1)
				first_sym_counts[first_sym] = -1;
		}
	}

	ll min_result{ -1 };
	char result;

	for (auto const& item : first_sym_counts)
	{
		if (item.second > 0)
		{
			if (min_result == -1)
			{
				result = item.first;
				min_result = item.second;
			}
			else
			{
				result = item.first;
				min_result = min(min_result, item.second);
			}
		}
	}

	if (min_result != -1)
	{
		for (auto i = 0; i < min_result + 1; ++i)
			cout << result;
	}
	else
		cout << "NO";
}
