#include <iostream>
#include <vector>
#include <cassert>
using namespace ::std;
#define forn(i, n) for (int i = 0; i < n; ++i)
typedef long long ll;
typedef vector<int> vi;
typedef vector<ll> vll;


constexpr int MOD = 998'244'353;

ll F(int n) {
    static vll vect = {0};
    if (n == -1)
        return 0;
    while (vect.size() <= n) {
        vect.push_back((vect.back() * 3 + 2) % MOD);
    }
    
    return vect[n];
}

ll G(int n, int p, const vi& vect) {
    if (n == 0)
        return 0;
    int pos = vect[n - 1];
    if (pos == p) {
        return G(n - 1, p, vect);
    }
    if (pos == 2) {
        return (G(n - 1, 4 - p, vect) + 1 + F(n - 1)) % MOD;
    }
    return (G(n - 1, p, vect) + 2 + 2 * F(n - 1)) % MOD;
}

void doWork() {
    int n;
    cin >> n;
    vi a(n), b(n);
    forn(i, n)
        cin >> a[i];
    forn(i, n)
        cin >> b[i];

    while (n != 0 && a.back() == b.back()) {
        --n;
        a.pop_back();
        b.pop_back();
    }

    if (n == 0) {
        cout << "0" << endl;
        return;
    }

    // x - откуда
    // y - куда
    int x = a.back(), y = b.back();
    assert(x != y);
    if (x == 1 && y == 3) {
        cout << (G(n - 1, 3, a) + 2 + F(n - 1) + G(n - 1, 1, b)) % MOD << endl;
        return;
    }
    if (x == 3 && y == 1) {
        cout << (G(n - 1, 1, a) + 2 + F(n - 1) + G(n - 1, 3, b)) % MOD << endl;
        return;
    }
    // слева
    if (x + y == 3) {
        cout << (G(n - 1, 3, a) + 1 + G(n - 1, 3, b)) % MOD << endl;
        return;
    }

    cout << (G(n - 1, 1, a) + 1 + G(n - 1, 1, b)) % MOD << endl;
    
    
    
    
}

signed main() {
    int t = 1;
    cin >> t;
    while (t--) {
        doWork();
    }
    
}