#include <iostream>
#include <algorithm>
#include <vector>
#include <map>

using namespace std;

#define int long long
int md = 998244353;
int bp(int a, int st){
    if(st == 0)
        return 1;
    if(st == 1)
        return a;
    int aa = a * a % md;
    return bp(aa, st / 2) * bp(a, st % 2) % md;
}

vector<pair<int, int>> cuts;
map<int, int> other;

void solve() {
    cuts.clear();
    other.clear();
    int n, m, k;
    cin >> n >> m >> k;
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        cuts.push_back({u, i});
        other[u] = v;
        other[v] = u;
        cuts.push_back({v, i});
    }
    sort(cuts.begin(), cuts.end());
    vector<int> stack;
    vector<int> sizes(m+1, 0);
    stack.push_back(m);
    stack.push_back(cuts[0].second);
    for (int i = 1; i < cuts.size(); i++) {
        sizes[stack[stack.size()-1]] += cuts[i].first - cuts[i-1].first + 1;
        if (stack.size() != cuts[i].second) {
            stack.push_back(cuts[i].second);
        } else {
            stack.pop_back();
        }
    }
    if (m == 0) {
        sizes[m] = n;
    } else {
        sizes[m] += cuts[0].first + n - cuts[cuts.size() - 1].first + 1;
    }

    int ans = 1;
    int obr_k = bp(k, md-2);
    for (int i = 0; i <= m; i++) {
        int t_ans = bp(k-1, sizes[i]-1) + 1;
        if (sizes[i] % 2 == 1) { t_ans -= 2;}
        if (t_ans < 0) t_ans += md;
        t_ans *= obr_k;
        t_ans %= md;
        ans *= t_ans;
        ans %= md;
    }
    ans *= k;
    ans %= md;
    ans *= (k-1);
    ans %= md;
    cout << ans << "\n";
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie();
    int t;
    cin >> t;
    while (t > 0) {
        t--;
        solve();
    }
    return 0;
}
