#include <algorithm>
#include <cassert>
#include <iostream>
#include <map>
#include <numeric>
#include <random>
#include <set>
#include <vector>

using namespace std;

#define int long long

#define ALL(c) c.begin(), c.end()

const int MOD = 998244353;

int sum(int x, int y) {
  return x + y < MOD ? x + y : x + y - MOD;
}

int mul(int x, int y) {
  return x * 1LL * y % MOD;
}

const int N = 1e5 + 7;

int n;
int x[N], y[N];

int h(int start, int finish, int n) {
  if (n == 0 || start == finish) {
    return 0;
  }
  static map<vector<int>, int> mem;
  if (mem.count({start, finish, n})) {
    return mem[{start, finish, n}];
  }
  int& res = mem[{start, finish, n}];
  int mi = start;
  int mj = finish;
  if (mi == mj) {
    return res = h(start, finish, n - 1) % MOD;
  } else {
    int ans = 0;
    if (mi == 0 && mj == 1) {
      ans = h(2, start, n - 1) + 1 + h(2, finish, n - 1);
    } else if (mi == 0 && mj == 2) {
      ans = h(2, start, n - 1) + 1 + h(2, 0, n - 1) + 1 + h(0, finish, n - 1);
    } else if (mi == 1 && mj == 0) {
      ans = h(2, start, n - 1) + 1 + h(2, finish, n - 1);
    } else if (mi == 1 && mj == 2) {
      ans = h(0, start, n - 1) + 1 + h(0, finish, n - 1);
    } else if (mi == 2 && mj == 1) {
      ans = h(0, start, n - 1) + 1 + h(0, finish, n - 1);
    } else if (mi == 2 && mj == 0) {
      ans = h(0, start, n - 1) + 1 + h(0, 2, n - 1) + 1 + h(2, finish, n - 1);
    }
    return res = ans % MOD;
  }
}

int g(int start, vector<vector<int>>& finish) {
  int n = finish[0].size() + finish[1].size() + finish[2].size();
  if (n == 0) {
    return 0;
  }
  int mi = start;
  int mj = -1;
  for (int i = 0; i < 3; ++i) {
    if (!finish[i].empty() && finish[i].back() == n - 1) {
      mj = i;
    }
  }
  assert(mj != -1);
  finish[mj].pop_back();
  if (mi == mj) {
    return g(start, finish);
  } else {
    int ans = 0;
    if (mi == 0 && mj == 1) {
      ans = h(2, start, n - 1) + 1 + g(2, finish);
    } else if (mi == 0 && mj == 2) {
      ans = h(2, start, n - 1) + 1 + h(2, 0, n - 1) + 1 + g(0, finish);
    } else if (mi == 1 && mj == 0) {
      ans = h(2, start, n - 1) + 1 + g(2, finish);
    } else if (mi == 1 && mj == 2) {
      ans = h(0, start, n - 1) + 1 + g(0, finish);
    } else if (mi == 2 && mj == 1) {
      ans = h(0, start, n - 1) + 1 + g(0, finish);
    } else if (mi == 2 && mj == 0) {
      ans = h(0, start, n - 1) + 1 + h(0, 2, n - 1) + 1 + g(2, finish);
    }
    return ans % MOD;
  }
}

int f(vector<vector<int>>& start, vector<vector<int>>& finish) {
  int n = start[0].size() + start[1].size() + start[2].size();
  if (n == 0) {
    return 0;
  }
  int mi = -1;
  for (int i = 0; i < 3; ++i) {
    if (!start[i].empty() && start[i].back() == n - 1) {
      mi = i;
    }
  }
  assert(mi != -1);
  int mj = -1;
  for (int i = 0; i < 3; ++i) {
    if (!finish[i].empty() && finish[i].back() == n - 1) {
      mj = i;
    }
  }
  assert(mj != -1);
  start[mi].pop_back();
  finish[mj].pop_back();
  if (mi == mj) {
    return f(start, finish);
  } else {
    int ans = 0;
    if (mi == 0 && mj == 1) {
      ans = g(2, start) + 1 + g(2, finish);
    } else if (mi == 0 && mj == 2) {
      ans = g(2, start) + 1 + h(2, 0, n - 1) + 1 + g(0, finish);
    } else if (mi == 1 && mj == 0) {
      ans = g(2, start) + 1 + g(2, finish);
    } else if (mi == 1 && mj == 2) {
      ans = g(0, start) + 1 + g(0, finish);
    } else if (mi == 2 && mj == 1) {
      ans = g(0, start) + 1 + g(0, finish);
    } else if (mi == 2 && mj == 0) {
      ans = g(0, start) + 1 + h(0, 2, n - 1) + 1 + g(2, finish);
    }
    return ans % MOD;
  }
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  int t;
  cin >> t;
  while (t--) {
    cin >> n;
    vector<vector<int>> start(3);
    for (int i = 0; i < n; ++i) {
      cin >> x[i];
      start[x[i] - 1].push_back(i);
    }
    vector<vector<int>> finish(3);
    for (int i = 0; i < n; ++i) {
      cin >> y[i];
      finish[y[i] - 1].push_back(i);
    }
    cout << f(start, finish) << '\n';
  }
  return 0;
}
/*
1
2
3 3
2 1
*/