#include <algorithm>
#include <cassert>
#include <iostream>
#include <numeric>
#include <random>
#include <vector>

using namespace std;

#define ALL(c) c.begin(), c.end()

const int MOD = 998244353;

int sum(int x, int y) {
  return x + y < MOD ? x + y : x + y - MOD;
}

int mul(int x, int y) {
  return x * 1LL * y % MOD;
}

const int N = 1e5 + 7;

int n;
int h[N], p[N];

int solve() {
  vector<vector<int>> arr;
  bool flag = false;
  int ans = 0;
  for (int i = 0; i < n; ++i) {
    arr.push_back({p[i], p[i] - h[i], h[i]});
    ans = max(ans, p[i] - h[i]);
    if (p[i] - h[i] < 0) {
      flag = true;
    }
  }
  sort(ALL(arr));
  for (int i = 0; i < n - 1; ++i) {
    if (arr[i][0] == arr[i + 1][0] && arr[i][1] != arr[i + 1][1]) {
      flag = true;
    }
    if (arr[i][1] > arr[i + 1][1] || arr[i][2] > arr[i + 1][2]) {
      flag = true;
    }
  }
  if (flag) {
    return -1;
  } else {
    return ans;
  }
}

int stupid_solve() {
  vector<int> arr(n);
  int x = 0;
  const int INF = 1e7;
  int res = 0;
  while (true) {
    int x = INF;
    for (int i = 0; i < n; ++i) {
      if (p[i] - arr[i] < h[i]) {
        return -1;
      }
      if (p[i] - arr[i] > h[i]) {
        x = min(x, p[i] - arr[i]);
      }
    }
    if (x == INF) {
      return res;
    }
    ++res;
    for (int i = 0; i < n; ++i) {
      if (p[i] - arr[i] >= x) {
        ++arr[i];
      }
    }
  }
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  int t;
  cin >> t;
  while (t--) {
    // n = 5;
    // cout << n << '\n';
    cin >> n;
    for (int i = 0; i < n; ++i) {
      // h[i] = rand() % 5 + 1;
      // cout << h[i] << ' ';
      cin >> h[i];
    }
    // cout << '\n';
    for (int i = 0; i < n; ++i) {
      // p[i] = rand() % 5 + 1;
      // cout << p[i] << ' ';
      cin >> p[i];
    }
    // cout << '\n';
    cout << solve() << '\n';
    // assert(solve() == stupid_solve());
  }
  return 0;
}