#include <algorithm>
#include <iostream>
#include <numeric>
#include <random>
#include <vector>

using namespace std;

#define ALL(c) c.begin(), c.end()

const int N = 1e5 + 7;

int n, m;
vector<int> g[N];

int cnt(vector<int>& order) {
  int res = 0;
  for (int v = 0; v < n; ++v) {
    for (int u : g[v]) {
      res += order[v] < order[u];
    }
  }
  return res;
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  mt19937 rnd(7);
  int t;
  cin >> t;
  while (t--) {
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
      int v, u;
      cin >> v >> u;
      --v, --u;
      g[v].push_back(u);
    }
    vector<int> order(n);
    iota(ALL(order), 0);
    for (int it = 0; it < 50; ++it) {
      shuffle(ALL(order), rnd);
      if (cnt(order) >= (m + 1) / 2) {
        break;
      }
    }
    if (cnt(order) >= (m + 1) / 2) {
      vector<int> ans(n);
      for (int v = 0; v < n; ++v) {
        ans[order[v]] = v;
      }
      for (int i = 0; i < n; ++i) {
        cout << ans[i] + 1 << ' ';
      }
      cout << '\n';
    } else {
      cout << "-1\n";
    }
  }
  return 0;
}