#include <algorithm>
#include <cassert>
#include <iostream>
#include <map>
#include <numeric>
#include <random>
#include <set>
#include <vector>

using namespace std;

#define ALL(c) c.begin(), c.end()

const int MOD = 998244353;

int sum(int x, int y) {
  return x + y < MOD ? x + y : x + y - MOD;
}

int mul(int x, int y) {
  return x * 1LL * y % MOD;
}

const int N = 107;

int n, e;
string s[N];

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  cin >> n >> e;
  map<char, int> r;
  for (int i = 0; i < e; ++i) {
    r['a' + i] = 0;
  }
  set<char> bad;
  for (int i = 0; i < n; ++i) {
    cin >> s[i];
    int cnt = 1;
    while (cnt < s[i].size() && s[i][0] == s[i][cnt]) {
      ++cnt;
    }
    if (cnt == s[i].size()) {
      bad.insert(s[i][0]);
    }
    r[s[i][0]] += cnt;
  }
  if (bad.size() == e) {
    cout << "NO\n";
    return 0;
  }
  char c = 'a';
  for (auto elem : r) {
    if (!bad.count(elem.first) && elem.second < r[c]) {
      c = elem.first;
    }
  }
  for (int i = 0; i < r[c] + 1; ++i) {
    cout << c;
  }
  cout << '\n';
  return 0;
}