#include <iostream>
#include <algorithm>
#include <functional>
#include <chrono>
#include <random>
#include <fstream>
#include <string>
#define fir first
#define sec second
#define ll long long
#define int ll
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sz(x) int(x.size())
#define pii pair <int, int>
#define pll pair <ll, ll>
#define vec vector
typedef std::vector<int> veci;
#define $ '\n'
using namespace std;

const int mod = 998'244'353;
const int inf = 2e9 + 7;
const ll INF = 2e18 + 7;

mt19937_64 gen(chrono::high_resolution_clock::now().time_since_epoch().count());
int random(int l, int r) {
    if (l > r) swap(l, r);
    return l + (gen() % (r - l + 1));
}

template <typename T>
ostream& operator << (ostream& os, const vector <T>& v) {
    for (const T& to: v) {
        os << to << ' ';
    }
    return os;
}

template <typename T>
istream& operator >> (istream& is, vector <T>& v) {
    for (T& to: v) {
        is >> to;
    }
    return is;
}


void solve() {
    int n;
    cin >> n;
    vector <int> from(n);
    cin >> from;
    vector <int> to(n);
    cin >> to;
    vector <vector <int>> st(4);
    st[1].push_back(n + 1);
    st[2].push_back(n + 1);
    st[3].push_back(n + 1);
    for (int i = n - 1; i >= 0; i--) {
        st[from[i]].push_back(i);
    }
    int dp[n + 1][4][4];
    for (int i = 0; i < n + 1; i++) {
        for (int j = 0; j < 4; j++) {
            for (int k = 0; k < 4; k++) {
                dp[i][j][k] = 0;
            }
        }
    }
    for (int i = 1; i <= n; i++) {
        dp[i][1][1] = dp[i][2][2] = dp[i][3][3] = 0;
        int swap2 = (dp[i-1][1][3] + 1 + dp[i-1][3][2]) % mod;
        dp[i][2][1] = dp[i][1][2] = swap2;
        dp[i][3][2] = dp[i][2][3] = swap2;
        dp[i][1][3] = dp[i][3][1] = (dp[i][1][2] + dp[i][2][3]) % mod;
    }

    int who = n - 1;
    while (who >= 0 && from[who] == to[who]) who--;
    if (who < 0) {
        cout << "0\n";
        return;
    }
    int pos = from[0];
    int cnt = 0;
    for (int i=0; i < who - 1; i++) {
        cnt += dp[i + 1][pos][to[i + 1]];
        cnt %= mod;
        pos = to[i + 1];
    }
    int pd_sz = who;
    int new_pos;
    if (abs(from[who] - to[who]) == 2) {
        new_pos = 6 - 2 - from[who];
        cnt += dp[pd_sz][pos][new_pos];
        cnt %= mod;
        pos = new_pos;
        from[who] = 2;
        cnt++;
        cnt %= mod;
    }
    new_pos = 6 - from[who] - to[who];
    cnt += dp[pd_sz][pos][new_pos];
    cnt %= mod;
    pos = new_pos;
    cnt++;
    cnt %= mod;
    for (int mv = who - 1; mv >= 0; mv--) {
        pd_sz--;
        if (abs(pos - to[mv]) == 2) {
            cnt += dp[pd_sz][1][3];
            cnt++;
            cnt %= mod;
            cnt += dp[pd_sz][1][3];
            cnt++;
            cnt %= mod;
        } else {
            new_pos = 6 - pos - to[mv];
            cnt += dp[pd_sz][pos][new_pos];
            pos = new_pos;
            cnt++;
            cnt %= mod;
        }
    }
    while (cnt < 0) cnt += mod;
    cnt %= mod;
    cout << cnt << endl;




}
/*
4
3 2 4 2
5 3 6 2
1
10
100000
5
1 2 3 4 5
1 2 3 4 5
3
1 4 6
4 1 8
 */

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1; cin >> t;
    while (t--) {
        solve();
        cout.flush();
    }
    return 0;
}