#include <algorithm>
#include <cassert>
#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <map>

using namespace std;
using ll = long long;


std::set<pair<int, int>> bridges;

void IS_BRIDGE(int v,int to) {
    bridges.insert({v, to});
    bridges.insert({to, v});
}
int n = 0;
vector<vector<int>> adj;
map <pair<int, int>, int> mp;


vector<bool> visited;
vector<int> tin, low;
int timer;

void dfs(int v, int p = -1) {
    visited[v] = true;
    tin[v] = low[v] = timer++;
    bool parent_skipped = false;
    for (auto to : adj[v]) {
        if (to == p && !parent_skipped) {
            parent_skipped = true;
            continue;
        }
        if (visited[to]) {
            low[v] = min(low[v], tin[to]);
        } else {
            dfs(to, v);
            low[v] = min(low[v], low[to]);
            if (low[to] > tin[v])
                IS_BRIDGE(v, to);
        }
    }
}

void find_bridges() {
    timer = 0;
    visited.assign(n, false);
    tin.assign(n, -1);
    low.assign(n, -1);
    for (int i = 0; i < n; ++i) {
        if (!visited[i])
            dfs(i);
    }
}

vector<int> used;
vector<int> way;
int s, f;
int fl = 0;

void dfs1(int v) {
    //cout << v << ' ';
    if (v == f) {
        way.push_back(v);
        fl = 1;
        return;
    }
    for (int u : adj[v]) {
        if (!used[u]) {
            used[u] = 1;
            dfs1(u);
            if (fl == 1) {
                way.push_back(v);
                if (v == s)
                    fl = 2;
                return;
            }
            if (fl == 2)
                return;
        }

    }
}

int solve(int r, int c, vector<vector<char>>& field) {
    vector<vector<char>> a(r, vector<char>(c));
    vector<vector<int>> b(r, vector<int>(c, -1));

    pair<int, int> sp, sf;

    for (int i = 0; i < r;i++) {
        for (int j = 0; j < c;j++) {
            a[i][j] = field[i][j];
            if (a[i][j] == 's') {
                sp = {i, j};
                a[i][j] = '.';
            }
            if (a[i][j] == 'f') {
                sf = {i, j};
                a[i][j] = '.';
            }
        }
    }

    char last = '#';
    vector<pair<int, int>> start;
    for (int i = 0; i < r;i++) {
        last = '#';
        for (int j = 0; j < c;j++) {
            if (a[i][j] == '.') {
                if (last == '.') {
                    b[i][j] = b[i][j - 1];
                }
                else {
                    b[i][j] = n++;
                    start.push_back({i, j});
                }

            }
            last = a[i][j];
            //cout << b[i][j] << ' ';
        }
        //cout << "\n";
    }

    adj.resize(n);

    for (int i = 0; i < r - 1;i++) {
        for (int j = 0; j < c; j++) {
            if (a[i][j] == '.' && a[i + 1][j] == '.') {
                pair<int, int> cur = {b[i][j], b[i + 1][j]}, rcur = {b[i + 1][j], b[i][j]};
                if (mp.find(cur) != mp.end()) {
                    mp[cur]++;
                    mp[rcur]++;
                }
                else {
                    adj[b[i][j]].push_back(b[i + 1][j]);
                    adj[b[i + 1][j]].push_back(b[i][j]);

                    mp[cur] = 1;
                    mp[rcur] = 1;
                }
            }
        }
    }

    find_bridges();

    s = b[sp.first][sp.second];
    f = b[sf.first][sf.second];

    used.clear();
    used.resize(n, 0);
    used[s] = 1;
    dfs1(s);

    int ans = 1e9;
    if (fl == 0 || way.size() <= 2) return -1;
    else {
        for (int i = 0; i < way.size() - 1;i++) {
            pair<int, int> cur = {way[i], way[i + 1]};
            if (bridges.find(cur) != bridges.end())
                ans = min(ans, mp[cur]);
        }
        for (int i = 1; i < way.size() - 1;i++) {
            if (bridges.find({way[i], way[i + 1]}) != bridges.end() &&
                bridges.find({way[i - 1], way[i]}) != bridges.end()) {
                int v = way[i];
                int pred = way[i - 1];
                int to = way[i + 1];

                int ii = start[v].first;
                int cnt = 0;
                for (int j = start[v].second; j < n;j++) {
                    if (a[ii][j] == '#')
                        break;
                    if (b[ii - 1][j] == pred && b[ii + 1][j] == to)
                        cnt++;
                    if (b[ii - 1][j] == to && b[ii + 1][j] == pred)
                        cnt++;
                }
                if (cnt)
                    ans = min(ans, cnt);
                //cout << pred << ' ' << v << ' ' << to << ' ' << cnt << "\n";
            }
        }


        int check = 1;
        if (sp.first + 1 < n) {
            if (b[sp.first + 1][sp.second] == way[way.size() - 2])
                check = 1e9;
        }
        if (sp.first - 1 >= 0) {
            if (b[sp.first - 1][sp.second] == way[way.size() - 2])
                check = 1e9;
        }
        ans = min(check, ans);


        check = 1;
        if (sf.first + 1 < n) {
            if (b[sf.first + 1][sf.second] == way[1])
                check = 1e9;
        }
        if (sf.first - 1 >= 0) {
            if (b[sf.first - 1][sf.second] == way[1])
                check = 1e9;
        }
        ans = min(check, ans);

        return ans;
    }

}

signed main() {
    //ios_base::sync_with_stdio(false);
    //cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {


        int r, c;
        cin >> r >> c;
        //cout << r << c;

        vector<vector<char>> field(r, vector<char>(c));
        vector<vector<char>> field1(c, vector<char>(r));
        for (int i = 0; i  <r;i++) {
            for (int j = 0; j < c;j++) {
                cin >> field[i][j];
            }
        }

        used.clear();
        way.clear();
        bridges.clear();
        adj.clear();
        mp.clear();
        n = 0;
        fl = 0;

        int ans1 = solve(r, c, field);

        used.clear();
        way.clear();
        bridges.clear();
        adj.clear();
        mp.clear();
        n = 0;
        fl = 0;

        for (int i = 0; i  <c;i++) {
            for (int j = i; j < r;j++) {
                field1[i][j] = field[j][i];
            }
        }

        int ans2 = solve(c, r, field1);

        if (ans1 == -1)
            cout << ans2;
        else if (ans2 == -1)
            cout << ans1;
        else cout << min(ans1, ans2);
        cout << "\n";
    }
}