#include <algorithm>
#include <cassert>
#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <map>

using namespace std;

#define int long long
const int modm = 998244353;


int fst(int a, int b) {
    if (b == 0) return 1;
    auto f = fst(a, b / 2);
    f *= f;
    f %= modm;
    if (b & 1) return (a * f) % modm;
    return f;
}

int solve_full_left_right(int n) {
    return (fst(3, n) + modm - 1) % modm;
}

int solve_left(int n, vector<int>& v, int up) {
    if (up == 0) return 0;
    if (v[up] == 1) return solve_left(n, v, up - 1);
    if (v[up] == 3) {
        auto answer = 2LL *  solve_full_left_right(up - 1) + 2 + solve_left(n, v, up - 1);
        return answer % modm;
    }
    if (v[up] == 2) {
        auto answer = 2LL * solve_full_left_right(up - 1) + 1 + solve_left(n, v, up - 1);
        return answer % modm;
    }
}

int solve_right(int n, vector<int> &v, int up) {
    std::vector<int> x(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        x[i] = 4 - v[i];
    }
    return solve_left(n, x, up);
}




signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<int> a(n);
        int ind = 0;
        for(int i = 0; i < n;i++) {
            cin >> a[i];
            if (a[i] < a[ind])
                ind = i;
        }

        int ans = 0;

        vector<int> p = a;


        int cur = p[ind];
        bool fl = 1;
        for (int i = 0; i < n;i++) {
            int ii = (ind + i) % n;
            if (p[ii] < cur)
                fl = 0;
            if (p[ii] > cur) {
                p[(ii + 1) % n] -= 2 * (p[ii] - cur);
                p[ii] = cur;
            }
        }
        for (int i = 0; i < n;i++) {
            if (p[i] != cur)
                fl = 0;
        }
        if (fl)
            ans = max(ans, cur);

        p = a;

        p[ind]--;
        p[(ind + 1) % n]-=2;

        cur = p[ind];
        fl = 1;
        for (int i = 0; i < n;i++) {
            int ii = (ind + i) % n;
            if (p[ii] < cur)
                fl = 0;
            if (p[ii] > cur) {
                p[(ii + 1) % n] -= 2 * (p[ii] - cur);
                p[ii] = cur;
            }
        }
        for (int i = 0; i < n;i++) {
            if (p[i] != cur)
                fl = 0;
        }
        if (fl)
            ans = max(ans, cur);

        p = a;

        p[ind] -= 2;
        p[(ind + n - 1) % n]--;

        cur = p[ind];
        fl = 1;
        for (int i = 0; i < n;i++) {
            int ii = (ind + i) % n;
            if (p[ii] < cur)
                fl = 0;
            if (p[ii] > cur) {
                p[(ii + 1) % n] -= 2 * (p[ii] - cur);
                p[ii] = cur;
            }
        }
        for (int i = 0; i < n;i++) {
            if (p[i] != cur)
                fl = 0;
        }
        if (fl)
            ans = max(ans, cur);

        p = a;

        p[ind] -= 2;
        p[(ind + 1) % n]-=4;

        cur = p[ind];
        fl = 1;
        for (int i = 0; i < n;i++) {
            int ii = (ind + i) % n;
            if (p[ii] < cur)
                fl = 0;
            if (p[ii] > cur) {
                p[(ii + 1) % n] -= 2 * (p[ii] - cur);
                p[ii] = cur;
            }
        }
        for (int i = 0; i < n;i++) {
            if (p[i] != cur)
                fl = 0;
        }
        if (fl)
            ans = max(ans, cur);

        cout << ans << "\n";
    }


}