#include <algorithm>
#include <cassert>
#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <map>
#include <deque>
using namespace std;
using ll = long long;


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        vector<int> cur_deg_out(n + 1, 0);
        vector<int> cur_deg_in(n + 1, 0);
        vector<vector<pair<int, int>>> g(n + 1);
        for (int i = 0; i < m; i++) {
            int u, v;
            cin >> u >> v;
            if (u >= v) {
                g[u].push_back({v, 1});
            }else {
                g[v].push_back({u, -1});
            }
        }
        deque<int> q;
        for (int i = 1; i <= n; i++) {
            for (auto &[to, we]: g[i]) {
                if (we == 1) {
                    cur_deg_out[i]++;
                    cur_deg_in[to]++;
                }
                else {
                    cur_deg_in[i]++;
                    cur_deg_out[to]++;
                }
            }
            if (cur_deg_out[i] >= cur_deg_in[i]) {
                q.push_front(i);
            }else {
                q.push_back(i);
            }
        }
        for (auto &d: q) {
            cout << d << " ";
        } cout << endl;
    }
}